io_uring_wait_cqes(3)

NAME
io_uring_wait_cqes - wait for one or more io_uring completion events

SYNOPSIS
#include <liburing.h>

int io_uring_wait_cqes(struct io_uring *ring,
                       struct io_uring_cqe **cqe_ptr,
                       unsigned wait_nr,
                       struct __kernel_timespec *ts,
                       sigset_t *sigmask);

DESCRIPTION

The io_uring_wait_cqes(3) function returns wait_nr IO completions from the queue belonging to the ring param, waiting for them if necessary or until the timeout ts expires.

The sigmask specifies the set of signals to block. If set, it is equivalent to atomically executing the following calls:

    sigset_t origmask;

    pthread_sigmask(SIG_SETMASK, &sigmask, &origmask);
    ret = io_uring_wait_cqes(ring, cqe, wait_nr, ts, NULL);
    pthread_sigmask(SIG_SETMASK, &origmask, NULL);

The cqe_ptr param is filled in on success with the first CQE. Callers of this function should use io_uring_for_each_cqe(3) to iterate all available CQEs.

If ts is specified and an older kernel without IORING_FEAT_EXT_ARG is used, the application does not need to call io_uring_submit(3) before calling io_uring_wait_cqes(3). For newer kernels with that feature flag set, there is no implied submit when waiting for a request.

If ts is NULL , then this behaves like io_uring_wait_cqe(3) in that it will wait forever for an event.

RETURN VALUE
On success io_uring_wait_cqes(3) returns 0 and the cqe_ptr param is filled in. On failure it returns -errno.

SEE ALSO
io_uring_submit(3), io_uring_for_each_cqe(3), io_uring_wait_cqe_timeout(3), io_uring_wait_cqe(3)